VERSION 2.00
Begin Form frmCancelDemo 
   Caption         =   "Cancel Print Demo"
   ClientHeight    =   2070
   ClientLeft      =   1695
   ClientTop       =   1800
   ClientWidth     =   3030
   Height          =   2475
   Left            =   1635
   LinkTopic       =   "Form1"
   ScaleHeight     =   2070
   ScaleWidth      =   3030
   Top             =   1455
   Width           =   3150
   Begin TextBox txtNbrPages 
      Height          =   285
      Left            =   1920
      TabIndex        =   2
      Text            =   "10"
      Top             =   1080
      Width           =   495
   End
   Begin CommandButton cmdStartJob 
      Caption         =   "Start Print Job"
      Height          =   735
      Left            =   600
      TabIndex        =   0
      Top             =   240
      Width           =   1815
   End
   Begin Line Line1 
      X1              =   120
      X2              =   2880
      Y1              =   1440
      Y2              =   1440
   End
   Begin Label lblNbrPages 
      Alignment       =   1  'Right Justify
      Caption         =   "Nbr of pages:"
      Height          =   255
      Left            =   600
      TabIndex        =   1
      Top             =   1080
      Width           =   1215
   End
   Begin Label lblJobStatus 
      Alignment       =   2  'Center
      Caption         =   "Print job inactive..."
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1680
      Width           =   2655
   End
End
Option Explicit

'If you have questions, comments, or suggestions for
'improving the code presented here, please forward them
'to me; you're input is welcome:
'
'        Brad Kaenel
'        PC HELP-LINE
'        35250 Silver Leaf Circle
'        Yucaipa, CA  92399
'        United States
'        CIS: 72357,3523
'        Internet: 72357.3523@compuserve.com
'

'We've all used commercial Windows applications that
'produce printed output, and witnessed the typical
'"Cancel Print" dialog box that's normally displayed
'while the output is being generated.  It's a common
'feature, but a difficult one to implement in VB.

'What makes it difficult is the requirement that the
'"Cancel" dialog be modal, so that the end-user is
'prevented from doing other things until the print
'job is either cancelled, or completes on its own.
'Since putting up a modal dialog box "freezes" the
'mainline logic of a VB application until the dialog
'is dismissed, the problem seems unsolvable.

'This sample demonstrates one technique for displaying
'an application-modal "Cancel" dialog, while a print
'job proceeds in the "background".  A status line on
'the dialog is updated continuously by the print job,
'to inform the end-user of its progress.  Clicking the
'dialog's "Cancel" button interrupts the print job.

'The technique works because:
'    1) The print job is initiated by the "Cancel"
'       dialog's _Activate event, not from the
'       application's mainline logic (which is, of
'       course, frozen).
'
'    2) The print job calls DoEvents as often as
'       is prudent, in order to give Windows a chance
'       to process a latent click on the "Cancel" button,
'       and to update the "status" message area.
'
'    3) A single, global "CancelPrint" flag is used as a
'       semaphore between the active print job and the
'       modal dialog box.  The flag is initially set to
'       False, but is set to True if the "Cancel" button
'       is clicked.  The print job is responsible for
'       periodically checking the status of the flag, and
'       halting itself if the flag is set to True.

Sub cmdStartJob_Click ()

nDesiredPages = Val(Trim$(frmCancelDemo.txtNbrPages.Text))
frmCancelDemo.txtNbrPages.Text = Trim$(Str$(nDesiredPages))
   
If nDesiredPages <= 0 Then
   Exit Sub
End If

tfCancelPrint = False
frmCancelDemo.lblJobStatus.Caption = "Print job started..."

Load frmPrintCancel
frmPrintCancel.Move frmCancelDemo.Left + frmCancelDemo.Width + 100, frmCancelDemo.Top + frmCancelDemo.Height - frmPrintCancel.Height

Load frmPrinter
frmPrinter.Move frmPrintCancel.Left, frmPrintCancel.Top + frmPrintCancel.Height + 100, frmPrintCancel.Width, frmPrintCancel.Height

frmPrinter.Show
frmPrintCancel.Show 1

frmCancelDemo.SetFocus

If tfCancelPrint Then
   frmCancelDemo.lblJobStatus.Caption = "Print job cancelled..."
Else
   frmCancelDemo.lblJobStatus.Caption = "Print job complete..."
End If

End Sub

Sub Form_Unload (Cancel As Integer)

Unload frmPrintCancel
Unload frmPrinter

End Sub

